/*
**  jAmpToo v1.3                                                     by Wout! (15aug2001)
**															modified by ilmcuts (2002-07-09)
**
**  Module displaying information about the currently playing winamp song.
**
**  Revision history:
**  TODO    + Limiting movement to desktop (err... how?)
**          + Find a fix for the LS tooltips not showing when jAmpToo is running!!!
**            (could be related to SetWindowRgn and real transparency :(
**
**  REQUEST ? Return of the Bounchy Scroller                   --- deadpuppies69@hotmail.com
**          ? Japanese font support (how???)                   --- tommyboy@optonline.net
**          ? Toggle to switch between Jamp and Grdamp support --- xnowfall@xnowerks.org
**
**  BUGS    ? Problem with ontop after toggle show/hide        --- deadpuppies69@hotmail.com
**
**          ? jAmpW, won't go past than 200                    --- bzImage@worldnet.att.net
**            * Weird, is just a GetRCInt... same should go for jAmpH too then.
**
**          ? Memory leak in v1.21, about 2Kb/sec when Win/GrdAmp is playing !Unloadmodule 
**            either module and the memory is freed.           --- xnowfall@xnowerks.org
**            * Haven't seen it myself, only checked for 'recycle' memleaks though...
**
**  v1.3    ! using GetRCCoordinate for x/y placement (ie. support for "c" and "%")
**(ilmcuts) ! compiled as "Multithreaded DLL" - size reduction
**          + Added %bitrate% to jAmpTitleFormat
**			+ Added jAmpOnAmpOpen/jAmpOnAmpClose
**			+ Added !jAmpScrollMode
**			* Fixed jAmpClick* commands not accepting parameters
**
**  v1.21   ! Updated jAmpUseGrdAmp to support v1.09
**
**  v1.2    NOTE: SETTINGS NOT BACKWARD COMPATIBLE WITH PREVIOUS VERSIONS!!!
**          * Almost completely rewritten!
**          ! Fixed text color bug
**          ! 'Fixed' crashing when WinAmp has "Scroll title in taskbar" enabled
**          + Rewrote scrolling (Scroll always or only when title too long)
**          + Added button clicks in title window
**          + jAmpScrollFiller: Sets text between repeating songtitle when scrolling
**          + Added support for GrdAmp (jAmpUseGrdAmp)
**          + Added text formatting for jAmpTime... settings (pos, rem, length, status)
**          + Clicking the time window toggles %pos% and %rem% in jAmpTimeFormat
**          + Added jAmpMove bang
**
**  v1.11   ! Fixed, set scroll = 0 when ScrollMode 1 and title fits!
**          ! Fixed hiding/showing bug
**
**  v1.1    + HideWhenNoWinamp option added (for non Wharf usage!)
**          ! Rewrote alignment routine (only for NON scrolling text)
**          + Scrolling! (Mode 1: circular, 2: out-in)
**          + Scroll speed setting (pixels/step)
**          + Seperate drawing of TIME display
**          + Clicking TIME area changes from pos to rem and vica-versa
**
**  v1.0    Initial version!
**          Added:   - LSBox/Wharf loadability
**                   - better transparency, background handling
**                   - lots of extra settings!
**          Removed: Title scrolling
**
**  Current Step.RC settings (default values between brackets):
**   - jAmpX                    X-Coord (allows negatives) [0]
**   - jAmpY                    Y-Coord (allows negatives) [0]
**   - jAmpW                    Width,  ONLY when jAmpBackBMP not used! [200]
**   - jAmpH                    Height, ONLY when jAmpBackBMP not used! [35]
**
**   - jAmpBackBmp              Background image, jAmpBackColor used if omitted [<none>]
**   - jAmpBackColor            Background fill color, ignored if jAmpBackBmp is used [FF00FF]
**   - jAmpTransparencyLevel    0 = none; 1 = LS fake transparency; [2] = REAL region trans
**
**                              NOTE: By default the window is AlwaysOnBottom
**   - jAmpFloat                Free float window (acts like a normal one)  [FALSE]
**   - jAmpAlwaysOnTop          Window Always on top                        [FALSE]
**   - jAmpAllowMove            Allow the user to move the window           [FALSE]
**
**   - jAmpStartHidden          Start jAmpToo hidden [FALSE]
**   - jAmpHideWhenNoWinamp     Hide when Winamp is not loaded (non Wharf/LSBox) [FALSE]
**   - jAmpNoWinampText         Text when winamp not loaded [""]
**
**   - jAmpUseGrdAmp            Gets it's data from GrdAmp v1.09 (or greater) instead of Winamp. 
**                              (See: http://floach.pimpin.net/grd/)
**
**   - jAmpScrollFiller         Text between repeating titles when scrolling ["     "]
**   - jAmpScrollMode           0 = off; 1 = only scroll long titles; [2] = scroll always
**   - jAmpScrollSpeed          Scrolling speed in pixels per step [2]
**
**                              NOTE: Text is aligned to the TOP of the TitleWindow!
**                                    Text can also be placed at negative values!
**   - jAmpTitleTop             Top of title display window         [0]
**   - jAmpTitleLeft            Left side of title display window   [0]
**   - jAmpTitleBottom          Bottom of title display window      [200]
**   - jAmpTitleRight           Right side of title display window  [22]
**
**   - jAmpTitleFormat          [%title%], %tnumber%, %pos%, %rem%, %length%, %status%, %bitrate%
**
**   - jAmpTitleAlign           Alignment of text: [0] = left; 1 = center; 2 = right
**   - jAmpTitleFont            Font            ["Tahoma"]
**   - jAmpTitleFontSize        Font Size       [20]
**   - jAmpTitleFontColor       Font Color      [FFFF00]
**   - jAmpTitleFontBold        Set bold        [FALSE]
**   - jAmpTitleFontItalic      Set itallic     [FALSE]
**   - jAmpTitleFontUnderline   Set Underline   [FALSE]
**
**   - jAmpTime                 Allows the time to be set in a location OTHER than the text!
**                              (see jAmpTime... settings below)
**
**                              NOTE: Text is aligned to the TOP of the TimeWindow!
**                                    Text can also be placed at negative values!
**   - jAmpTimeTop              Top of time display window          [18]
**   - jAmpTimeLeft             Left side of time display window    [0]
**   - jAmpTimeBottom           Bottom of time display window       [35]
**   - jAmpTimeRight            Right side of time display window   [40]
**
**   - jAmpTimeFormat           %pos%, %rem%, %length%, %status% [(%pos%/%length%)]
**                              (Clicking the time window will toggle %pos% and %rem%)
**
**   - jAmpTimeAlign            Alignment of text: [0] = left; 1 = center; 2 = right
**   - jAmpTimeFont             Font            ["Tahoma"]
**   - jAmpTimeFontSize         Font Size       [18]
**   - jAmpTimeFontColor        Font Color      [A0A0A0]
**   - jAmpTimeFontBold         Set bold        [FALSE]
**   - jAmpTimeFontItalic       Set itallic     [FALSE]
**   - jAmpTimeFontUnderline    Set Underline   [FALSE]
**
**   - jAmpMove X Y             Moves jAmpToo to position (X,Y) (negative values allowed)
**   - jAmpClickLeft            Command or bang to perform on left click    [""]
**   - jAmpClickRight           Command or bang to perform on right click   [""]
**   - jAmpClickDouble          Command or bang to perform on double click  [""]
*/

/*------------------------------------------------------------------------------------------------
**
** Includes and prototypes
** Watch out for path to lsapi.h! 
**
*/
#include <windows.h>
#include "..\development\lsapi\common.h"
#include "jAmpToo.h"
#include "exports.h"

void LoadRCSettings();
void BangShow(HWND,   const char*);
void BangHide(HWND,   const char*);
void BangToggle(HWND, const char*);
void BangMove(HWND,   const char*);
void BangScrollMode(HWND,   const char*);
LRESULT CALLBACK WndProcMain(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);


/*------------------------------------------------------------------------------------------------
**
** Module load functions
** Wharf loading is passed on to regular module loading 
**
*/
int initWharfModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType *wd)
{
	dockedOnWharf = TRUE;		// loaded as wharf
    isFreeForm = wd == NULL;	// for LSBox compatibility
	return initModuleEx (ParentWnd, dllInst, NULL);
}

int initModuleEx(HWND lsParent, HINSTANCE dllInst, LPCSTR szPath)
{
    // Store for module destruction
    hwndParent = lsParent;

	// Load all settings from Step.RC
    LoadRCSettings();

	// Add the bang commands...
    if (!dockedOnWharf)
    {
        AddBangCommand("!jampShow",   BangShow);
        AddBangCommand("!jampHide",   BangHide);
        AddBangCommand("!jampToggle", BangToggle);
		AddBangCommand("!jampMove",   BangMove);
    }

	AddBangCommand("!jAmpScrollMode",BangScrollMode);
	
    // Create the window
    WNDCLASSEX wc;
	memset(&wc,0,sizeof(wc));
	wc.cbSize = sizeof(wc);
	wc.hInstance = dllInst;
	wc.style = CS_DBLCLKS;
	wc.lpfnWndProc = WndProcMain;
	wc.lpszClassName = "jAmpTooMain";
    if (!RegisterClassEx(&wc)) 
	{ 
		MessageBox(hwndParent, "Error: Could not register window class!", "LiteStep :: jAmpToo", MB_OK | MB_ICONERROR); 
		return 1; 
	}

    hwndMain = CreateWindowEx(dockedOnWharf?WS_EX_TRANSPARENT:WS_EX_TOOLWINDOW, 
                              "jAmpTooMain", "jAmpTooMain",
                              (dockedOnWharf || !jAmpFloat)?WS_CHILD:WS_POPUP, 
                              dockedOnWharf?0:Parent.X, dockedOnWharf?0:Parent.Y,
                              Parent.W, Parent.H,
							  (!jAmpFloat)?hwndParent:NULL, NULL, dllInst, NULL);
	if (!hwndMain) return 1;

    // Set 'show on all desktops' and register with Litestep
    SetWindowLong(hwndMain, GWL_USERDATA, magicDWord);
	SendMessage(hwndParent, LM_REGISTERMESSAGE, (WPARAM)hwndMain, (LPARAM)msgs);

    // Set window parent according to users wishes, desktop for always-on-bottom, nothing for floating and AOT. 
    if (!dockedOnWharf)
    {
        if (jAmpFloat) 
        {
            if (jAmpAlwaysOnTop) SetWindowPos(hwndMain, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOMOVE);
        }
        else
        {
            HWND hwndDesktop = FindWindow("DesktopBackgroundClass", NULL); 
            if (!hwndDesktop) hwndDesktop = GetDesktopWindow();
            SetParent(hwndMain, hwndDesktop);
        }
    }

	// Show the window (or not) 
    if (!jAmpStartHidden | dockedOnWharf) 
	{
		ShowWindow(hwndMain, SW_SHOWNA); //SW_SHOW
		jAmpHidden = FALSE;
	}
    	
	// Set timer for checking the WinAmp title
    SetTimer(hwndMain, 0, 100, NULL);
   
    return 0;
}


/*------------------------------------------------------------------------------------------------
**
** Module quit functions.
** Again the Wharf unloading is passed on to the regular quit function.
**
*/
int quitWharfModule(HINSTANCE dllInst)
{
	return quitModule(dllInst);
}

int quitModule(HINSTANCE dllInst)
{
	KillTimer(hwndMain, 0);

    if (!dockedOnWharf)
    {
        RemoveBangCommand("!jampShow");
	    RemoveBangCommand("!jampHide");
	    RemoveBangCommand("!jampToggle");
		RemoveBangCommand("!jampMove");
    }

	RemoveBangCommand("!jAmpScrollMode");
	
    SendMessage(hwndParent, LM_UNREGISTERMESSAGE, (WPARAM)hwndMain, (LPARAM)msgs);
	
	DestroyWindow(hwndMain);
	UnregisterClass("jAmpTooMain", dllInst);

	DeleteObject(BGbrush);
	DeleteObject(hBGbmp);
	DeleteObject(jAmpTitleFont);
	DeleteObject(jAmpTimeFont);

    return 0;
}


/*+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
**
** Main window proc to handle all window events:
**
**	LM_GETREVID			- Allow LiteStep to retrieve module info
**	WM_ERASEBKGND		- Fallthrough too painting routine(?)
**	WM_PAINT			- Paints the background, title and time onto the window
**	WM_TIMER			- Regularly checks WinAmp for song information
**	WM_LBUTTONDBLCLK	- Capture double click actions
**	WM_LBUTTONDOWN		- Check leftclick actions, including dragging and time mode changes
**	WM_RBUTTONDOWN		- Capture rightclicks
**
*/
LRESULT CALLBACK WndProcMain(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		case LM_GETREVID:
		{
			strcpy((char *) lParam, "jAmpToo v1.3");
			return strlen((char *) lParam);
		}
		break;

		case WM_ERASEBKGND: return 1;
		
		case WM_PAINT:
		{

		//--- Start painting: create a work buffer DC and bitmap!
        
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd, &ps);
			HDC buf = CreateCompatibleDC(NULL);
            HBITMAP bufbmp = CreateCompatibleBitmap(hdc, Parent.W, Parent.H);
            RECT r;

			// I want to change a bitmap in the buffer!
            HBITMAP oldbuf = (HBITMAP)SelectObject(buf, bufbmp);

            // Select the hBGbmp into the src hDC, and blit it into the buffer...
            if (hBGbmp)
            {
                HDC src = CreateCompatibleDC(NULL);
				HBITMAP oldsrc = (HBITMAP)SelectObject(src, hBGbmp);
			    BitBlt(buf, 0, 0, Parent.W, Parent.H, src, 0, 0, SRCCOPY);
				SelectObject(src, oldsrc); 
				DeleteDC(src);
            }
            else // ...or fill the window with a solid color if there is no bitmap
            {
                GetClientRect(hwnd, &r);
                FillRect(buf, &r, (HBRUSH)BGbrush);
            }


		//--- Now I want to write the title text into the buffer!
	    
			// Set the next drawings to transparent so we won't mess up the background
			int oldbkmode = SetBkMode(buf, TRANSPARENT);

			HGDIOBJ oldfont = SelectObject(buf, jAmpTitleFont);
	        COLORREF oldcol  = SetTextColor(buf, jAmpTitleFontColor);
						
			static int txtRefX = Title.Left; // Offset from clipping window
   			int textWidth;
			char temp[512] = "";
			strcpy(temp, title);

			// Calculate the width of the title text
			SetRectEmpty(&r);
			ret = DrawText(buf, temp, strlen(temp), &r, DT_SINGLELINE | DT_CALCRECT);
			textWidth = r.right;

			// If the user wants scrolling AND (the text is wide enough OR wants to scroll any way) OR 'Anti Crash'
			if ( (jAmpScrollMode > 0) & ( (textWidth > TITLEWIDTH) | (jAmpScrollMode == 2) ) | WinAmpScrollDetected)
			{
				/* HOW TO SCROLL:
				**    Scrolling is done by sliding the text out at the left side of clipping window.
				**    As soon as the whole text has been scrolled out, the sliding pointer is set back
				**    to it's origin. In order to create the illusion of a cyclic scroller, the text 
				**    needs to be repeated at least once (depending on how many times the title fits 
				**    within the clipping window)
				**
				**    [Count]     [WindowString]         [offset]
				**    (0)         |Title  Title| Title      0
				**    (1)         |itle  Title |Title      -1     
				**    (2)        T|tle  Title  |itle       -2
				**    (3)       Ti|le  Title  T|tle        -3
				**    (4)      Tit|e  Title  Ti|le         -4
				**    (5)     Titl|  Title  Tit|e          -5
				**    (6)    Title| Title  Titl|           -6
				**    (7|0)       |Title  Title| Title      0
				**
				**    ...etcetera, ad nauseum...
				*/
				
				strcat(temp, jAmpScrollFiller);
				ret = DrawText(buf, temp, strlen(temp), &r, DT_SINGLELINE | DT_CALCRECT);
				textWidth = r.right;

				SetTextAlign(buf,0);
				// Title text repeater...
				strcat(temp, title);
				strcat(temp, jAmpScrollFiller);
				while ( r.right < TITLEWIDTH ) 
				{	
					ret = DrawText(buf, temp, strlen(temp), &r, DT_SINGLELINE | DT_CALCRECT);
					strcat(temp, title);
					strcat(temp, jAmpScrollFiller);
				};
				
				// The actual scroller and the sliding scroll pointer!
				if (txtRefX <= (-textWidth + Title.Left)) txtRefX = Title.Left;
				txtRefX -= jAmpScrollSpeed;
			}
			else
			{
				// No scrolling this time, set the text alignment
				SetTextAlign(buf, jAmpTitleAlign);
				if      (jAmpTitleAlign == TA_RIGHT ) txtRefX =  Title.Right;
				else if (jAmpTitleAlign == TA_CENTER) txtRefX = (Title.Right /2 ) + (Title.Left / 2);
				else						          txtRefX =  Title.Left;
			}

			// Draw the text into the clipping rectangle
			SetRect(&r, Title.Left, Title.Top, Title.Right, Title.Bottom);
			ExtTextOut(buf, txtRefX, Title.Top, ETO_CLIPPED, &r, temp, strlen(temp), NULL);
			
	        // clean up the leftovers
			SelectObject(buf, oldfont);
	        SetTextColor(buf, oldcol);


		//--- Now I want to print the play time!

			if (jAmpTime)
			{	
				int timeRefX;
				HGDIOBJ oldfont = SelectObject(buf, jAmpTimeFont);
				COLORREF oldcol  = SetTextColor(buf, jAmpTimeFontColor);
			
				// Align the text
				SetTextAlign(buf, jAmpTimeAlign);
				if      (jAmpTimeAlign == TA_RIGHT ) timeRefX =  Time.Right;
				else if (jAmpTimeAlign == TA_CENTER) timeRefX = (Time.Right /2 ) + (Time.Left / 2);
				else								 timeRefX =  Time.Left;

				// Draw the text into the clipping rectangle
				SetRect(&r, Time.Left, Time.Top, Time.Right, Time.Bottom);
				ExtTextOut(buf, timeRefX, Time.Top, ETO_CLIPPED, &r, ptime, strlen(ptime), NULL);

		        // clean up the leftovers
				SelectObject(buf, oldfont);
		        SetTextColor(buf, oldcol);
			}			

			
		//--- Blit everything back to the actual hDC!
            
			// REAL region transparency (way coolest!)
			if (jAmpTransparencyLevel==2)
            {
                SelectObject(buf,oldbuf);
			    HRGN region = BitmapToRegion(bufbmp, 0x00EF00EF, 0x00101010, 0, 0);
			    SetWindowRgn(hwnd,region,true);
			    oldbuf = (HBITMAP) SelectObject(buf,bufbmp);
            }
            
			// LS fake transparency (causes trouble when text is on transparent part of background!!!)
			if (jAmpTransparencyLevel==1)  
            {
                TransparentBltLS(hdc, 0,0, Parent.W, Parent.H, buf, 0,0, RGB(255,0,255));
            }
            
			// Fall through to blit region transparency / blit without transparency
			else  
            {
                BitBlt(hdc, 0, 0, Parent.W, Parent.H, buf, 0, 0, SRCCOPY);
            }
            
            // Clean up some stuff and end painting!
			SelectObject(buf, oldbuf); DeleteDC(buf); DeleteObject(bufbmp);
			SetBkMode(buf, oldbkmode);
			EndPaint(hwnd, &ps);
			
			return 0;
        }
		break;
		
		case WM_TIMER:
		{
			static boolean bWinampOpen = false;
			
			// Find winamp
			if (!winamp) winamp = FindWindow( PlayerWndClass , NULL);
		    else if (!IsWindow(winamp)) winamp = FindWindow( PlayerWndClass , NULL);

		    if (winamp)
		    {
				if (!bWinampOpen)
				{
					bWinampOpen = true;
					LSExecute(NULL, jAmpOnAmpOpen, SW_SHOWNORMAL);
				}
				
				if (!IsWindowVisible(hwndMain) & !jAmpHidden) ShowWindow(hwndMain, SW_SHOW);

			    char temp[256] = "";
				GetWindowText(winamp, temp, 256);

				// Anti crash! Detect when WinAmp is scrolling it's title in the taskbar!
				WinAmpScrollDetected = FALSE;
				if (strstr(temp, "** ") != NULL) WinAmpScrollDetected = TRUE;

			    char tnum[256] = "";
				char tbuf[256] = "";
				char* p = strstr(temp, " - Winamp");
                char* n = strstr(temp, ". ");

				if ( ((p != NULL) & !WinAmpScrollDetected) | (jAmpUseGrdAmp & (strlen(temp) > 0)) )
                { 
		            // Chop up the title and the tracknumber (uses pointer arithmatic!)
	                if (jAmpUseGrdAmp)
					{
						strcpy(tbuf, temp); // Only the title for GrdAmp
					}
					else 
					{
						strncpy(tnum, temp, n-temp);
						strncpy(tbuf, (n+2), p-(n+2));
					}

				    // Get and calculate the play time
					int length = SendMessage(winamp, WM_USER, 1, 105);
				    int position = SendMessage(winamp, WM_USER, 0, 105);
					int bitrate = SendMessage(winamp, WM_USER, 1, 126);

					int remaining = length - (position/1000);
					if (length != -1) sprintf(len, "%d:%02d", length/60, length%60); else sprintf(len, "0:00");
				    if (position != -1) sprintf(pos, "%d:%02d", position/1000/60, position/1000%60); else sprintf(pos, "0:00");
				    if (length != -1 && position != -1) sprintf(rem, "%d:%02d", remaining/60, remaining%60); else sprintf(rem, "0:00");
				    if (bitrate != -1) sprintf(bitr, "%d", bitrate); else sprintf(bitr, "0");

				    // Transform title according to jAmpTitleFormat
				    memset(&title, 0, sizeof(title));
					char* titleformat = _strdup(jAmpTitleFormat);
					char* tit = strtok(titleformat, "%");
				    while (tit)
				    {
					    if (!_stricmp(tit, "title"))		strcat(title, tbuf);
					    else if (!_stricmp(tit, "tnumber"))	strcat(title, tnum);
					    else if (!_stricmp(tit, "length"))	strcat(title, len);
					    else if (!_stricmp(tit, "pos"))	    strcat(title, pos);
					    else if (!_stricmp(tit, "rem"))	    strcat(title, rem);
					    else if (!_stricmp(tit, "status")) 
					    {
						    int s = SendMessage(winamp, WM_USER, 0, 104);
							strcat(title, (s == 1)? "Playing" : (s == 3)? "Paused" : "Stopped");
					    }
						else if (!_stricmp(tit, "bitrate"))	    strcat(title, bitr);
					    else strcat(title, tit);

                        tit = strtok(NULL, "%");
                    }

					if (jAmpTime)
					{	
						// Transform time according to jAmpTimeFormat
						memset(&ptime, 0, sizeof(ptime));
						char* ptimeformat = _strdup(jAmpTimeFormat);
						char* tim = strtok(ptimeformat, "%");
					    while (tim)
					    {
						    if (!_stricmp(tim, "pos"))			strcat(ptime, pos);
							else if (!_stricmp(tim, "length"))	strcat(ptime, len);
						    else if (!_stricmp(tim, "rem"))	
							{
								strcat(ptime, "-");
								strcat(ptime, rem);
							}
						    else if (!_stricmp(tim, "status")) 
						    {
							    int s = SendMessage(winamp, WM_USER, 0, 104);
								strcat(ptime, (s == 1)? "Playing" : (s == 3)? "Paused" : "Stopped");
						    }
						    else strcat(ptime, tim);
	
							tim = strtok(NULL, "%");
						}
					}
			    }
				else if (WinAmpScrollDetected)
				{
					// Anti Crash handling: display message for user
					strcpy(title,"Please turn off \"Scroll title in taskbar\" in WinAmp -> CTRL+P -> Display...");
				}
				else
				{
					// Exeption: when winamp is loaded, but no song has been loaded into the player
					// set the title to a single space in order to fool DrawText/DT_CALCRECT function
					strcpy(title," ");
				}
		    }
            else
            {
				if (bWinampOpen)
				{
					bWinampOpen = false;
					LSExecute(NULL, jAmpOnAmpClose, SW_SHOWNORMAL);
				}

				if (jAmpHideWhenNoWinamp & IsWindowVisible(hwndMain)) ShowWindow(hwndMain, SW_HIDE);
	            memset(&title, 0, sizeof(title)); 
				strcat(title, jAmpNoWinampText);
            }
			InvalidateRect(hwndMain, NULL, TRUE);
			return 0;
		}
		break;

        case WM_LBUTTONDBLCLK:
		case WM_LBUTTONDOWN:
		case WM_RBUTTONDOWN:
	    {
		    // Get the click position
			int xPos = LOWORD(lParam);
			int yPos = HIWORD(lParam);
			
			// A click in the time window?
			if ( (jAmpTime > 0) & (xPos > Time.Left) & (xPos < Time.Right) & (yPos > Time.Top) & (yPos < Time.Bottom) )
			{
				char* p = strstr(jAmpTimeFormat, "%pos%");
				if (p != NULL)
				{
					strncpy( jAmpTimeFormat + (p - jAmpTimeFormat), "%rem%", 5 );
				}
				else
				{
					char* p = strstr(jAmpTimeFormat, "%rem%");
					if (p != NULL) strncpy( jAmpTimeFormat + (p - jAmpTimeFormat), "%pos%", 5 );
				}
			}

			// A click in the title window?
			if ( (xPos > Title.Left) & (xPos < Title.Right) & (yPos > Title.Top) & (yPos < Title.Bottom) )
			{
				char command[256]="";
				if (msg == WM_LBUTTONDOWN)   LSExecute(NULL, jAmpClickLeft, SW_SHOWNORMAL);
				if (msg == WM_RBUTTONDOWN)   LSExecute(NULL, jAmpClickRight, SW_SHOWNORMAL);
				if (msg == WM_LBUTTONDBLCLK) LSExecute(NULL, jAmpClickDouble, SW_SHOWNORMAL);
			}

			// Or a left-mouse drag action?
			if (jAmpAllowMove && !dockedOnWharf) SendMessage(hwnd, WM_SYSCOMMAND, SC_MOVE|2, lParam);
			return 0;
		}
        break;
    }
	return DefWindowProc(hwnd,msg, wParam,lParam);
}


/*------------------------------------------------------------------------------------------------
**
** Load all the settings from the StepRC
**
*/
void LoadRCSettings()
{
   	char temp[256] = "";

	GetRCString("jAmpBackBmp", temp, "", 256);
	hBGbmp = LoadLSImage(temp,temp);
	if (!hBGbmp)
	{
		COLORREF BGcolor = GetRCColor("jAmpBackColor", 0xFF00FF);
		BGbrush  = CreateSolidBrush(BGcolor);
		Parent.W = GetRCInt("jAmpW", 200);
		Parent.H = GetRCInt("jAmpH", 35);
	}
	else
	{
		GetObject(hBGbmp, sizeof(BGbmp), &BGbmp);
		Parent.W = BGbmp.bmWidth;
		Parent.H = BGbmp.bmHeight;
	}

/*    Parent.X = GetRCInt("jAmpX", 0); 
		if (Parent.X < 0) Parent.X = GetSystemMetrics(SM_CXSCREEN) + Parent.X;
		if (Parent.X > GetSystemMetrics(SM_CXSCREEN)) Parent.X = GetSystemMetrics(SM_CXSCREEN) - Parent.W;
    Parent.Y = GetRCInt("jAmpY", 0); 
		if (Parent.Y < 0) Parent.Y = GetSystemMetrics(SM_CYSCREEN) + Parent.Y;
		if (Parent.Y > GetSystemMetrics(SM_CYSCREEN)) Parent.Y = GetSystemMetrics(SM_CYSCREEN) - Parent.H;*/

	Parent.X = GetRCCoordinate("jAmpX", 0, GetSystemMetrics(SM_CXSCREEN));
	Parent.Y = GetRCCoordinate("jAmpY", 0, GetSystemMetrics(SM_CYSCREEN));

	jAmpTransparencyLevel	= GetRCInt("jAmpTransparencyLevel", 2);

    jAmpFloat				= GetRCBool("jAmpFloat", TRUE);
    jAmpAllowMove			= GetRCBool("jAmpAllowMove", TRUE);
    jAmpAlwaysOnTop			= GetRCBool("jAmpAlwaysOnTop", TRUE); 
		if (jAmpAlwaysOnTop) jAmpFloat = TRUE;
    jAmpStartHidden			= GetRCBool("jAmpStartHidden", TRUE);
	jAmpHideWhenNoWinamp	= GetRCBool ("jAmpHideWhenNoWinamp", TRUE);

    GetRCString("jAmpNoWinampText", jAmpNoWinampText, " ", 256);
	GetRCString("jAmpTitleFormat", jAmpTitleFormat, "%title%", 256);
		if (jAmpTitleFormat == "") strcat(jAmpTitleFormat, "%title%");
	GetRCString("jAmpTimeFormat", jAmpTimeFormat, "(%pos%/%length%)", 256);
		if (jAmpTimeFormat == "") strcat(jAmpTimeFormat, "(%pos%/%length%)");
	

	// Work around for LSAPI bug!
	// Leading and trailing whitespaces within "quotes" are deleted by LSAPI!
	GetRCLine( "jAmpScrollFiller", jAmpScrollFiller, 256, "   ");
	if (strstr(jAmpScrollFiller, "\"")) 
	{
		char *p = strtok(jAmpScrollFiller, "\""); 
		strcpy(jAmpScrollFiller, p);
	}

	jAmpScrollMode  = GetRCInt("jAmpScrollMode", 2);
	jAmpScrollSpeed = GetRCInt("jAmpScrollSpeed", 2);

	jAmpUseGrdAmp = GetRCBool("jAmpUseGrdAmp", TRUE);
	if (jAmpUseGrdAmp) strcpy(PlayerWndClass, GrdWndClass);
    
    jAmpTime = GetRCBool("jAmpTime", TRUE);

	Title.Left   = GetRCInt("jAmpTitleLeft",    0);
    Title.Top    = GetRCInt("jAmpTitleTop",     0);
    Title.Right  = GetRCInt("jAmpTitleRight", 200);
    Title.Bottom = GetRCInt("jAmpTitleBottom", 22);

	Time.Left	 = GetRCInt("jAmpTimeLeft",     0);
    Time.Top	 = GetRCInt("jAmpTimeTop",     18);
    Time.Right	 = GetRCInt("jAmpTimeRight",   40);
    Time.Bottom  = GetRCInt("jAmpTimeBottom",  35);


    jAmpTitleFontColor = GetRCColor("jAmpTitleFontColor", 0x00FFFF); 
    jAmpTimeFontColor  = GetRCColor("jAmpTimeFontColor",  0xA0A0A0); 

    GetRCString("jAmpTitleFont", temp, "Tahoma", 256);
    jAmpTitleFont = CreateFont(GetRCInt("jAmpTitleFontSize",20), 0, 0, 0, 
                          GetRCBool("jAmpTitleFontBold",TRUE)?600:0, 
						  GetRCBool("jAmpTitleFontItalic",TRUE)?TRUE:FALSE, 
						  GetRCBool("jAmpTitleFontUnderline",TRUE)?TRUE:FALSE,
                          FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, temp);

    GetRCString("jAmpTimeFont", temp, "Tahoma", 256);
    jAmpTimeFont  = CreateFont(GetRCInt("jAmpTimeFontSize",18), 0, 0, 0, 
                          GetRCBool("jAmpTimeFontBold",TRUE)?600:0, 
						  GetRCBool("jAmpTimeFontItalic",TRUE)?TRUE:FALSE, 
						  GetRCBool("jAmpTimeFontUnderline",TRUE)?TRUE:FALSE,
                          FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, temp);

	jAmpTitleAlign = GetRCInt("jAmpTitleAlign", 0);
	if      (jAmpTitleAlign == 2) jAmpTitleAlign = (TA_RIGHT  | TA_TOP);
	else if (jAmpTitleAlign == 1) jAmpTitleAlign = (TA_CENTER | TA_TOP);
	else					      jAmpTitleAlign = (TA_LEFT   | TA_TOP);

	jAmpTimeAlign = GetRCInt("jAmpTimeAlign", 1);
	if      (jAmpTimeAlign == 2)  jAmpTimeAlign = (TA_RIGHT  | TA_TOP);
	else if (jAmpTimeAlign == 1)  jAmpTimeAlign = (TA_CENTER | TA_TOP);
	else						  jAmpTimeAlign = (TA_LEFT   | TA_TOP);

	GetRCLine("jAmpClickLeft",   jAmpClickLeft, MAX_LINE_LENGTH, "");
	GetRCLine("jAmpClickRight",  jAmpClickRight, MAX_LINE_LENGTH, "");
	GetRCLine("jAmpClickDouble", jAmpClickDouble, MAX_LINE_LENGTH, "");

	GetRCLine("jAmpOnAmpOpen", jAmpOnAmpOpen, MAX_LINE_LENGTH, "");
	GetRCLine("jAmpOnAmpClose", jAmpOnAmpClose, MAX_LINE_LENGTH, "");
}

/*------------------------------------------------------------------------------------------------
**
** Bang command handlers
**
*/
void BangShow(HWND caller, const char* dummy) 
{
    ShowWindow(hwndMain, SW_SHOW);
	jAmpHidden = FALSE;
}

void BangHide(HWND caller, const char* dummy) 
{ 
    ShowWindow(hwndMain, SW_HIDE);
	jAmpHidden = TRUE;
}

void BangToggle(HWND caller, const char* dummy)
{
	if (IsWindowVisible(hwndMain)) BangHide(caller, dummy);
	else BangShow(caller, dummy);
}

void BangMove(HWND caller, const char* xchar)
{
	if (xchar)
	{
		char* ychar = strstr(xchar, " ");
		int xpos = atoi(xchar);
		int ypos = atoi(ychar);

		if (xpos < 0) xpos = GetSystemMetrics(SM_CXSCREEN) + xpos;
		if (ypos < 0) ypos = GetSystemMetrics(SM_CYSCREEN) + ypos;
		
		SetWindowPos(hwndMain, 0, xpos, ypos, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOZORDER);
	}
}

void BangScrollMode(HWND caller, const char* args) 
{ 
	switch (args[0])
	{
		case '0':
			jAmpScrollMode = 0;
			break;
		case '1':
			jAmpScrollMode = 1;
			break;
		case '2':
			jAmpScrollMode = 2;
			break;
		default:;
	}
}

/*=============================================================================================*/
